program Conflict
  ! Conflict -- Synthetic data of conflicting dips.
  !%
  use sep
  use int1
  use interp
  use random_mod

  implicit none
  integer                            :: nt, nx, it, ix, stat
  real, dimension (:,:), allocatable :: data
  real, dimension (:),   allocatable :: t, amp
  real                               :: t0, x0, dt, dx

  call sep_init ()
  call from_par ("n1", nt, 150)
  call from_par ("n2", nx, 80 )

  t0 = 0.; x0= 0.
  dt = 1./nt; dx= 1.

  call to_history ("d1", dt) ; call to_history ("d2", dx)
  call to_history ("o1", t0) ; call to_history ("o2", x0)

  call to_history ("esize",4)
  call sep_close ()

  allocate (data(nt,nx))

  call random_init (1992)   ! coding begins with Heal synthetics.
  call random (data, 1.e-2)

  allocate (t   (15))
  allocate (amp (15))

  do ix= 1, nx 
     amp = (1.*ix)/ nx
     t   = (/ (it *dt + (.4  * ix) / nx, &
     it = -2*nt, 3*nt, nt/3) /)
     call int1_init (t,t0,dt,nt,lin_int,15,2)
     stat = int1_lop (.true.,.true.,data (:,ix),amp)
  end do
  deallocate (t, amp)
  call int1_close ()

  allocate (t   (25))
  allocate (amp (25))
  do ix = 1, nx
     amp = (nx-ix+1.)/ nx
     t   = (/ (it *dt + (.7  * (nx-ix)) / nx, &
     it = -2*nt, 3*nt, nt/5) /)
     call int1_init (t,t0,dt,nt,lin_int,15,2)
     stat = int1_lop (.true.,.true.,data (:,ix),amp)
  end do
  deallocate (t, amp)
  call int1_close ()

  call sep_write (data)
  deallocate (data)
  call exit (0)
end program Conflict
