program Lomoplan
  ! Lomoplan -- Local Mono Plane Annihilator
  !
  ! < in.H Lomoplan agc=0 eps=0. gap=1 > out.H
  !  See code for w1,w2,a1,a2,k1,k2 defaults.
  !
  ! out.H has 4 panels, 1=input, 2=lomoplan 3=patches 4=luna
  ! out.H has 5 panels, 1=input, 2=lomoplan 3=patches 4=luna 5=dm
  !
  !% end of self documentation
  use sep
  use decon2
  use tent_mod
  use patching_mod
  use triangle
  use random_mod

  implicit none
  integer, dimension (2)            :: n, w, k, a, lag, gap
  real, dimension (:,:), pointer    :: modl, resi, wind
  real, dimension (:), allocatable  :: temp
  integer                           :: postrect, i, stat

  call sep_init ()
  call from_history (n (1), n (2))

  call from_par ("w1", w (1), 20)
  call from_par ("w2", w (2), 6 )

  call from_par ("a1", a (1), 7)
  call from_par ("a2", a (2), 2)

  k = 1.5 * n / (w - a + 1.)

  call from_par ("k1", k (1), k (1))
  call from_par ("k2", k (2), k (2))

  call from_par ("postrect1", postrect, 1)

  call to_history ("n3",2)
  call sep_close ()

  allocate (modl (n (1), n (2)))
  allocate (resi (n (1), n (2))) 

  call sep_read (modl)
  call random (resi, 1.e-4)

  modl = modl / maxval (abs (modl)) + resi

  lag (1) = a (1) / 2 + 1
  lag (2) = 1

  gap = 0

  allocate (wind (w (1), w (2)))

  call tent (a, lag, wind)
  call decon2_init (w, a, lag, gap)
  call patching (decon2_img, modl, resi, k, wind)
  call decon2_close ()

  allocate (temp (n (1)))
  call triangle_init (postrect, n (1))
  do i = 1, n (2)
     stat = triangle_op (.true.,.false.,temp,resi(:,i))
     resi(:,i) = temp
  end do
  call triangle_close ()

  call sep_write (modl)
  call sep_write (resi)

  deallocate (modl, resi, wind, temp)

  call exit (0)
end program Lomoplan

