# Conflict -- Synthetic data of conflicting dips.
#%
integer                    nt,        nx
from par:	integer n1:nt=150, n2:nx=80
#from par:	integer n1:nt=75, n2:nx=80
allocate:	real datr(nt,nx), diff(nt,nx)

subroutine doit( nt,nx, datr, diff)
integer it,nt, ix,nx, iseed
real datr( nt,nx), diff(nt,nx)
real t, t0,dt, x0, dx, rand01, amp
iseed = 1992
#call putch('nt','i',nt)
#call putch('nx','i',nx)
t0 = 0;		x0= 0;
dt = 1./nt;	dx= 1.
call putch( 'd1','f', dt)
call putch( 'o1','f', t0)
call putch( 'd2','f', dx)
call putch( 'o2','f', x0)
call hclose()
call zero( nt*nx, datr)
				# coding begins with Heal synthetics.
do it= 1, nt {
do ix= 1, nx {
	datr(it,ix) = datr(it,ix) + (rand01(iseed)-.5) * 1.e-2
	}}
do ix= 1, nx {
	do it= -2*nt, 3*nt, nt/3 {
		amp = (1.*ix)/ nx
		t   = it *dt + (.4  * ix) / nx
		call spot1( 0,1, nt, t0,dt,t, amp, datr(1,ix))
		}
	do it= -2*nt, 3*nt, nt/5 {
		amp = (nx-ix+1.)/ nx
		t   = it *dt + (.22 * (nx-ix)) / nx
		t   = it *dt + (.7  * (nx-ix)) / nx
		call spot1( 0,1, nt, t0,dt,t, amp, datr(1,ix))
		}
	}
call srite('out', datr, 4*nt*nx)
return; end



# Nearest neighbor interpolation would do this:    val = vec( 1.5 + (t-t0)/dt)
# This is the same but with _linear_ interpolation.
#
subroutine spot1( adj, add, nt,t0,dt, t, val,    vec    )
integer it, itc,  adj, add, nt
real tc, fraction,             t0,dt, t, val,    vec(nt)
call adjnull(    adj, add,               val, 1, vec,nt)
tc      = (t-t0) / dt
itc     =  tc
it      = 1 + itc;			fraction = tc - itc
if( 1 <= it  &&  it < nt)
	if( adj == 0) {					# add value onto vector
		vec(it  ) = vec(it  ) + (1.-fraction) * val
		vec(it+1) = vec(it+1) +   fraction    * val
		}
	else						# take value from vector
		val = val + (1.-fraction) * vec(it)  +  fraction * vec(it+1)
return;	end
